/*******************************************************************************
 * Copyright (c) 2012 IBM Corporation and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompanies this distribution.
 *
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 *
 *     Michael Fiedler     - initial API and implementation for Bugzilla adapter
 *     Jad El-khoury        - initial implementation of code generator (https://bugs.eclipse.org/bugs/show_bug.cgi?id=422448)
 *
 * This file is generated by org.eclipse.lyo.oslc4j.codegenerator
 *******************************************************************************/
package se.kth.md.assume.adaptors.gitlab.services;

import java.io.IOException;
import java.io.PrintWriter;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.Consumes;
import javax.ws.rs.DELETE;
import javax.ws.rs.FormParam;
import javax.ws.rs.GET;
import javax.ws.rs.HeaderParam;
import javax.ws.rs.POST;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.Response.Status;
import javax.ws.rs.core.UriInfo;
import javax.ws.rs.core.UriBuilder;

import org.apache.wink.json4j.JSONObject;
import org.eclipse.lyo.oslc4j.provider.json4j.JsonHelper;
import org.eclipse.lyo.oslc4j.core.annotation.OslcCreationFactory;
import org.eclipse.lyo.oslc4j.core.annotation.OslcDialog;
import org.eclipse.lyo.oslc4j.core.annotation.OslcDialogs;
import org.eclipse.lyo.oslc4j.core.annotation.OslcQueryCapability;
import org.eclipse.lyo.oslc4j.core.annotation.OslcService;
import org.eclipse.lyo.oslc4j.core.model.Compact;
import org.eclipse.lyo.oslc4j.core.model.OslcConstants;
import org.eclipse.lyo.oslc4j.core.model.OslcMediaType;
import org.eclipse.lyo.oslc4j.core.model.Preview;
import org.eclipse.lyo.oslc4j.core.model.ServiceProvider;
import org.eclipse.lyo.oslc4j.core.model.Link;
import org.eclipse.lyo.oslc4j.core.model.AbstractResource;

import se.kth.md.assume.adaptors.gitlab.GitLabManager;
import se.kth.md.assume.adaptors.gitlab.GitLabConstants;
import se.kth.md.assume.adaptors.gitlab.servlet.ServiceProviderCatalogSingleton;
import se.kth.md.assume.adaptors.gitlab.resources.ChangeRequest;
import se.kth.md.assume.adaptors.gitlab.resources.Person;

// Start of user code imports
// End of user code

// Start of user code pre_class_code
// End of user code
@OslcService(GitLabConstants.CHANGE_MANAGEMENT_DOMAIN)
@Path("cm-services/{serviceProviderId}/changeRequests")
public class ChangeRequestService
{
    @Context private HttpServletRequest httpServletRequest;
    @Context private HttpServletResponse httpServletResponse;
    @Context private UriInfo uriInfo;

    // Start of user code class_attributes
    // End of user code

    // Start of user code class_methods
    // End of user code

    public ChangeRequestService()
    {
        super();
    }

    @OslcQueryCapability
    (
        title = "QueryCapabilityCR",
        label = "QueryCapabilityCR",
        resourceShape = OslcConstants.PATH_RESOURCE_SHAPES + "/" + GitLabConstants.PATH_CHANGEREQUEST,
        resourceTypes = {GitLabConstants.TYPE_CHANGEREQUEST},
        usages = {OslcConstants.OSLC_USAGE_DEFAULT}
    )
    @GET
    @Path("querychangerequests")
    @Produces({OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_XML, OslcMediaType.APPLICATION_JSON})
    public ChangeRequest[] queryChangeRequests(
                                                    @PathParam("serviceProviderId") final String serviceProviderId ,
                                                     @QueryParam("oslc.where") final String where,
                                                     @QueryParam("page") final String pageString,
                                                    @QueryParam("limit") final String limitString) throws IOException, ServletException
    {
        int page=0;
        int limit=20;
        if (null != pageString) {
            page = Integer.parseInt(pageString);
        }
        if (null != limitString) {
            limit = Integer.parseInt(limitString);
        }

        // Start of user code queryChangeRequests
        // Here additional logic can be implemented that complements main action taken in GitLabManager
        // End of user code

        final List<ChangeRequest> resources = GitLabManager.queryChangeRequests(httpServletRequest, serviceProviderId, where, page, limit);
        return resources.toArray(new ChangeRequest [resources.size()]);
    }

    @GET
    @Path("querychangerequests")
    @Produces({ MediaType.TEXT_HTML })
    public Response queryChangeRequestsAsHtml(
                                    @PathParam("serviceProviderId") final String serviceProviderId ,
                                       @QueryParam("oslc.where") final String where,
                                       @QueryParam("page") final String pageString,
                                    @QueryParam("limit") final String limitString) throws ServletException, IOException
    {
        int page=0;
        int limit=20;
        if (null != pageString) {
            page = Integer.parseInt(pageString);
        }
        if (null != limitString) {
            limit = Integer.parseInt(limitString);
        }

        // Start of user code queryChangeRequestsAsHtml
        // End of user code

        final List<ChangeRequest> resources = GitLabManager.queryChangeRequests(httpServletRequest, serviceProviderId, where, page, limit);

        if (resources!= null) {
            httpServletRequest.setAttribute("resources", resources);
            // Start of user code queryChangeRequestsAsHtml_setAttributes
            // End of user code

            httpServletRequest.setAttribute("queryUri",
                    uriInfo.getAbsolutePath().toString() + "?oslc.paging=true");
            if (resources.size() > limit) {
                resources.remove(resources.size() - 1);
                httpServletRequest.setAttribute("nextPageUri",
                        uriInfo.getAbsolutePath().toString() + "?oslc.paging=true&amp;page=" + (page + 1));
            }
            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/assume/adaptors/gitlab/queryresults-NEW.jsp");
            rd.forward(httpServletRequest,httpServletResponse);
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @GET
    @Path("{resourceId}")
    @Produces({OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_XML, OslcMediaType.APPLICATION_JSON})
    public ChangeRequest getChangeRequest(
                @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("resourceId") final String resourceId
        ) throws IOException, ServletException, URISyntaxException
    {
        // Start of user code getResource_init
        // End of user code

        final ChangeRequest aChangeRequest = GitLabManager.getChangeRequest(httpServletRequest, serviceProviderId, resourceId);

        if (aChangeRequest != null) {
            // Start of user code getChangeRequest
            // End of user code
            return aChangeRequest;
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @GET
    @Path("{resourceId}")
    @Produces({ MediaType.TEXT_HTML })
    public Response getChangeRequestAsHtml(
        @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("resourceId") final String resourceId
        ) throws ServletException, IOException, URISyntaxException
    {
        // Start of user code getChangeRequestAsHtml_init
        // End of user code

        final ChangeRequest aChangeRequest = GitLabManager.getChangeRequest(httpServletRequest, serviceProviderId, resourceId);

        if (aChangeRequest != null) {
            httpServletRequest.setAttribute("aChangeRequest", aChangeRequest);
            // Start of user code getChangeRequestAsHtml_setAttributes
            httpServletRequest.setAttribute("abstractResource", (AbstractResource)aChangeRequest);
            // End of user code

            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/assume/adaptors/gitlab/resourcepresentation-NEW.jsp");
            rd.forward(httpServletRequest,httpServletResponse);
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

}
